#!/usr/bin/env python
#
# This script was written by Dr. Simona Schiavi. Do not hesitate to contact me at
# simona.schiavi@polytechnique.edu if you notice any bug or if you need assistance
#
import multiprocessing
import os
import errno #error handling
import shutil #bash utils
import numpy as np

# split a list into evenly sized chunks
def chunks(l, n):
    return [l[i:i+int(n)] for i in range(0, len(l), int(n))]


def do_job(job_id, data_slice):
    for item in data_slice:
        proc = 'recon-all -s ' + fsurfer_path + '/' + item + ' -brainstem-structures'
        os.system(proc)


def dispatch_jobs(data, job_number):
    total = len(data)
    chunk_size = total / job_number
    slice = chunks(data, chunk_size)
    jobs = []

    for i, s in enumerate(slice):
        print('Dispatch arguments', i, s)
        j = multiprocessing.Process(target=do_job, args=(i, s))
        jobs.append(j)
    for j in jobs:
        j.start()



if __name__ == "__main__":
    
    #set path for the analysis outputh
    path_Np = '...'
    path_data = path_Np + '/fsurfer'
    path_Analysis = path_Np
    fsurfer_path= path_Analysis + '/fsurfer'


    os.environ["SUBJECTS_DIR"] = fsurfer_path
    cmd = "echo $SUBJECTS_DIR"
    os.system(cmd) 
    
    
    Subj_list = [f for f in os.listdir(path_data) if not f.startswith('.') and os.path.isdir(os.path.join(path_data,f))]
    Subj_list.sort()
    print(Subj_list)
    
    dispatch_jobs(Subj_list, 4)